-- Format:		Maxscript 3ds Max 4
--
-- Title:		Standard Mesh to plaintext
--
clearlistener()
DSMscale = 10

f = 1 -- just for closing later
fout = 1

objectName = "testBF_m1"
fsname = "C:\\smASCIIout.txt" -- save file name
fname = getOpenFileName caption:"Import .sm" types:"Standard Mesh .sm|*.sm|All|*.*|"
if fname != undefined do
(
	fout = createFile fsname
	if fout != undefined do
	(
		format "*SM_ASCII\t%" 100 to:fout
		format "\n*COMMENT \"AsciiExport Standard Mesh Version  %\" " 1.00 to:fout
		f=fopen fname "rb"

		format "\n*HEADER {" to:fout

		SM_HeaderV = (Readlong f)
		format "\n\t*HEADER_VERSION %" SM_HeaderV to:fout

		if SM_HeaderV <= 10 do
		(
			qVerts = #()
			VertMod = #()

			qFaces = #()
			FaceMod = #()

			fseek f 4 #seek_cur

			extractBB = true
			if extractBB == true then
			(
				tmp1 = (ReadFloat f)*DSMscale
				tmp2 = (ReadFloat f)*DSMscale
				tmp3 = (ReadFloat f)*DSMscale
				tmp4 = (ReadFloat f)*DSMscale
				tmp5 = (ReadFloat f)*DSMscale
				tmp6 = (ReadFloat f)*DSMscale
				format "\n\t*BBOX_MIN \t% \t% \t%" tmp1 tmp3 tmp2 to:fout
				format "\n\t*BBOX_MAX \t% \t% \t%" tmp4 tmp6 tmp5 to:fout
			)
			else
			(
				fseek f 24 #seek_cur
			)


			if SM_HeaderV == 10 do
			(
				fseek f 1 #seek_cur
			)

			
			numTopModels = (Readlong f #unsigned)
			format "\n}\n*COLLISION_COUNT %" numTopModels to:fout

			for i=1 to numTopModels do
			(
				format "\n*MESH_NUMBER %" i to:fout
				SizeOfSection = (Readlong f #unsigned)
				format "\n\t*MESH_BYTES %\t//Offset %" SizeOfSection (ftell f) to:fout
				endOffset = (ftell f)+SizeOfSection
			
			
					-- these 8 bytes seem to be a header
				fseek f 8 #seek_cur
					
				numVerts = (Readlong f #unsigned)
				format "\n\t*MESH_VERTICES %" numVerts to:fout
				for j=1 to numVerts do
				(	
					vert1 = (ReadFloat f)*DSMscale
					vert2 = (ReadFloat f)*DSMscale
					vert3 = (ReadFloat f)*DSMscale
					VertMod[j] = (ReadShort f #unsigned)+1 -- MatID?

					format "\n\t\t*MESH_VERTEX %\t% \t% \t%" j vert1 vert3 vert2 to:fout

					fseek f 2 #seek_cur -- Stuff of vert1 Repeated
					qVerts[j] = (point3 vert1 vert3 vert2)
				)

				numFaces = (Readlong f #unsigned)
				format "\n\t*MESH_FACES %" numFaces to:fout
				for j=1 to numFaces do
				(	
					FaceA = (ReadShort f #unsigned)+1
					FaceB = (ReadShort f #unsigned)+1 
					FaceC = (ReadShort f #unsigned)+1
					FaceMod[j] = (ReadShort f #unsigned)+1
					format "\n\t\t*MESH_FACE %\t% \t% \t% \t%" j FaceA FaceB FaceC FaceMod[j] to:fout
				)

				Unknown1 = ReadLong f #unsigned
				Unknown2 = ReadLong f #unsigned
				format "\n\t*UNKNOWN_1 %" Unknown1 to:fout
				format "\n\t*UNKNOWN_2 %" Unknown2 to:fout
				FaceNormals = ReadLong f #unsigned
				format "\n\t*FACENORMAL_COUNT %" FaceNormals to:fout

				for j=1 to FaceNormals do
				(	
					vert1 = (ReadFloat f)
					vert2 = (ReadFloat f)
					vert3 = (ReadFloat f)
					format "\n\t\t*FACENORMAL_VECTOR %\t% \t% \t%" j vert1 vert3 vert2 to:fout
					fseek f 20 #seek_cur
				)
				
				if Unknown1 == FaceNormals then
				(
					if Unknown2 == 0 do
					(
						fseek f 24 #seek_cur
						tmp1 = ReadLong f
						fseek f (tmp1*4+6) #seek_cur
					)
				)
				else
				(
					tmp1 = ftell f
					print ("EOS "+(i as string)+": "+(tmp1 as string))
					print ("EOS "+"END: "+(endOffset as string))
					print ("EOS Size "+(i as string)+": "+((endOffset-tmp1) as string))
					fseek f endOffset #seek_set
				)

				print ("FaceMod: "+(FaceMod as string))
				print ("Unknown1: "+(Unknown1 as string))
				print ("Unknown2: "+(Unknown2 as string))
				print ("FaceNormals: "+(FaceNormals as string))
				format "\n\n//////////////////-----------//////////////////\n" to:fout
			)
		)
		fclose f
		close fout
	)
)
